/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2006-2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: tSIOPortMacOSX.c 296 2009-05-08 12:00:36Z ertl-hiro $
 */

/*
 *		ꥢI/OǥХSIO˥ɥ饤СMac OS Xѡ
 */

#include "tSIOPortMacOSX_tecsgen.h"
#include "tSIOPortMacOSX.h"
#include <errno.h>
#include <unistd.h>
#include <fcntl.h>
#include <termios.h>
#include <t_stddef.h>
#include <t_syslog.h>

/*
 *  SIOɥ饤Фνλ
 */
void
tSIOPortMacOSX_terminate(intptr_t exinf)
{
	CELLIDX	idx = (CELLIDX) exinf;
	CELLCB	*p_cellcb;

	assert(VALID_IDX(idx));
	p_cellcb = GET_CELLCB(idx);

	/*
	 *  ץ󤵤Ƥ륷ꥢI/OݡȤΥ
	 */
	if (VAR_openflag) {
		eSIOPort_close(idx);
	}
}

/*
 *  ꥢI/OݡȤΥץ
 */
void
eSIOPort_open(CELLIDX idx)
{
	CELLCB			*p_cellcb;
	int_t			fd;
	struct termios	term;

	assert(VALID_IDX(idx));
	p_cellcb = GET_CELLCB(idx);

	if (ATTR_path != NULL) {
		fd = open((const char *) ATTR_path, O_RDWR, 0777);
		assert(fd >= 0);
		VAR_read_fd = VAR_write_fd = fd;
	}
	else {
		fd = VAR_read_fd = STDIN_FILENO;		/* ɸϤȤ */
		VAR_write_fd = STDOUT_FILENO;
	}
	fcntl(fd, F_SETOWN, getpid());
	fcntl(fd, F_SETFL, (O_NONBLOCK | O_ASYNC));

	tcgetattr(fd, &(VAR_saved_term));
	term = VAR_saved_term;
	term.c_lflag &= ~(ECHO | ICANON);
	tcsetattr(fd, TCSAFLUSH, &term);

	VAR_rcv_flag = false;
	VAR_rcv_ready = false;
	VAR_snd_flag = false;
	VAR_snd_ready = false;
	VAR_openflag = true;
}

/*
 *  ꥢI/OݡȤΥ
 */
void
eSIOPort_close(CELLIDX idx)
{
	CELLCB	*p_cellcb;

	assert(VALID_IDX(idx));
	p_cellcb = GET_CELLCB(idx);

	tcsetattr(VAR_read_fd, TCSAFLUSH, &(VAR_saved_term));
	fcntl(VAR_read_fd, F_SETFL, 0);

	if (ATTR_path != NULL) {
		close(VAR_read_fd);
	}
	VAR_openflag = false;
}

/*
 *  SIOγߥӥ롼
 */
void
tSIOPortMacOSX_isr(intptr_t exinf)
{
	CELLCB	*p_cellcb = (CELLCB *) exinf;
	int_t	n;

	if (VAR_snd_flag) {
		if ((n = write(VAR_write_fd, &(VAR_snd_buf), 1)) > 0) {
			VAR_snd_flag = false;
			if (VAR_snd_ready) {
				ciSIOCBR_readySend();
			}
		}
	}
	if (!VAR_rcv_flag) {
		if ((n = read(VAR_read_fd, &(VAR_rcv_buf), 1)) > 0) {
			VAR_rcv_flag = true;
			if (VAR_rcv_ready) {
				ciSIOCBR_readyReceive();
			}
		}
	}
}

/*
 *  ꥢI/OݡȤؤʸ
 */
bool_t
eSIOPort_putChar(CELLIDX idx, char_t c)
{
	CELLCB	*p_cellcb;
	int_t	n;

	assert(VALID_IDX(idx));
	p_cellcb = GET_CELLCB(idx);

	if (!VAR_snd_flag) {
		if ((n = write(VAR_write_fd, &c, 1)) > 0) {
			return(true);
		}
		else {
			assert(n < 0 && errno == EAGAIN);
			VAR_snd_flag = true;
			VAR_snd_buf = c;
			return(true);
		}
	}
	else {
		return(false);
	}
}

/*
 *  ꥢI/OݡȤʸ
 */
int_t
eSIOPort_getChar(CELLIDX idx)
{
	CELLCB	*p_cellcb;
	char_t	c;
	int_t	n;

	assert(VALID_IDX(idx));
	p_cellcb = GET_CELLCB(idx);

	if (VAR_rcv_flag) {
		VAR_rcv_flag = false;
		return((int_t)(uint8_t)(VAR_rcv_buf));
	}
	else if ((n = read(VAR_read_fd, &c, 1)) > 0) {
		return((int_t)(uint8_t) c);
	}
	else {
		assert(n < 0 && errno == EAGAIN);
		return(-1);
	}
}

/*
 *  ꥢI/OݡȤΥХåε
 */
void
eSIOPort_enableCBR(CELLIDX idx, uint_t cbrtn)
{
	CELLCB	*p_cellcb;

	assert(VALID_IDX(idx));
	p_cellcb = GET_CELLCB(idx);

	switch (cbrtn) {
	case SIO_RDY_SND:
		VAR_snd_ready = true;
		break;
	case SIO_RDY_RCV:
		VAR_rcv_ready = true;
		break;
	}
}

/*
 *  ꥢI/OݡȤΥХåζػ
 */
void
eSIOPort_disableCBR(CELLIDX idx, uint_t cbrtn)
{
	CELLCB	*p_cellcb;

	assert(VALID_IDX(idx));
	p_cellcb = GET_CELLCB(idx);

	switch (cbrtn) {
	case SIO_RDY_SND:
		VAR_snd_ready = false;
		break;
	case SIO_RDY_RCV:
		VAR_rcv_ready = false;
		break;
	}
}
