#ifndef TOPPERS_TERMIOS_H
#define TOPPERS_TERMIOS_H

#define	NCCS		20

#define ECHO		0x00000008	/* enable echoing */
#define	ICANON		0x00000100	/* canonicalize input lines */

typedef unsigned long	tcflag_t;
typedef unsigned char	cc_t;
typedef long		speed_t;	/* XXX should be unsigned long */

struct termios {
	tcflag_t	c_iflag;	/* input flags */
	tcflag_t	c_oflag;	/* output flags */
	tcflag_t	c_cflag;	/* control flags */
	tcflag_t	c_lflag;	/* local flags */
	cc_t		c_cc[NCCS];	/* control chars */
	speed_t		c_ispeed;	/* input speed */
	speed_t		c_ospeed;	/* output speed */
};

#define	TCSAFLUSH	2		/* drain output, flush input */

extern int tcgetattr(int fd, struct termios *t);
extern int tcsetattr(int fd, int action, const struct termios *t);

#endif /* TOPPERS_TERMIOS_H */
