/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id:
 */
                
/*
 *   J[lp̃X^[gAbvW[(mindstormsNXTp)
 */
#define    TOPPERS_MACRO_ONLY
#define UINT_C(val)		(val)		/* uint_t^̒萔}N */
#define ULONG_C(val)	(val)		/* ulong_t^̒萔}N */
#include "kernel_impl.h"

/*
 * ̂߂̃}N
 */
	.macro  mem_copy,  source, source_end, dest
	ldr   r0,=\source
	ldr   r1,=\source_end
	ldr   r2,=\dest
	bl    mem_copy_func
	.endm

	.macro mem_initialise, dest, dest_end, val
	ldr   r0,=\dest
	ldr   r1,=\dest_end
	ldr   r2,=\val
	bl    mem_init_func
	.endm

	.macro mac_string str
	.string \str
	.endm

/* ܂Ń}N */

	.global start	
	.global undef_handler
	.global swi_handler
	.global prefetch_abort_handler
	.global data_abort_handler
	.global reserved_handler
	.global _kernel_sta_ker

	.section .text
	.code 32
	.align 	0

start:
	/*
	 * FIQ/IRQ֎~
	 */
	mrs  r0,cpsr
	orr  r0,r0,#(CPSR_INTLOCK)
	msr  cpsr_all,r0

	/*
	 * ̃}bvȂĂ邩̃`FbN
	 */
	ldr  r0,=0x000000
	ldr  r2,=0x200000
	ldr  r3,[r0]      /* r3 <- 0x0000 0000 ɂf[^ */
	ldr  r4,[r2]      /* r4 <- 0x0200 0000 ɂf[^ */
	ldr  r5,=0xFFFFFFFF
	eor  r5,r4,r5     /* r5 <- 0x0200 0000 ɂf[^rbg] */
	str  r5,[r2]      /* r5 -> 0x0200 0000  */
	ldr  r5,[r0]      /* r5 <- 0x0000 0000 ɂf[^ */
	str  r4,[r2]      /* r4 -> 0x0200 0000  */

	cmp  r3,r5             /* 0x0000 0000 ɂf[^ω */
	bne  continue_boot /* ωĂ烊}bv̕Kv͂Ȃ */

	/*
	 *  ̃}bvs
	 */
	ldr  r0,=0xFFFFFF00 /* Memory Controler */
	ldr  r1,=1
	str  r1,[r0]        /* }bv : SRAM̃gbv(2MB)A0ԒnANZXł悤 */

continue_boot:
    /*
     * hardware_init_hooǩĂяo i0łȂꍇj
     *
     * ^[Qbgn[hEFAɈˑĕKvȏꍇ
     * ́Chardware_init_hook Ƃ֐pӂ
     */
    ldr   r0, =hardware_init_hook
    cmp   r0, #0x00
    movne lr, pc
    movne pc, r0 
	
	/*
	 * xN^e[u[ḧ悩RAM̐擪ɃRs[
	 * }bv@\ɂRAM̐擪xN^AhXɌĂ
	 * ̕ƃt@[EFAɂ܂
	 */
vector_copy:
	mem_copy       __vectors_load_start__, __vectors_load_end__, __vectors_ram_start__

	/*
	 * ̈̏
	 */
data_copy:
	mem_copy       __data_load_start__, __data_load_end__, __data_ram_start__
ram_text_copy:
	mem_copy       __ramtext_load_start__, __ramtext_load_end__, __ramtext_ram_start__
bss_init:
	mem_initialise __bss_start__, __bss_end__, 0
/* stack_init_0:
	mem_initialise __stack_start__, __stack_end__, 0x6b617453
 */

	/*
	 * X^bN|C^̏
	 */
stack_init_1:
	/*
     * X[p[oCU[[hCFIQ/IRQ֎~
     */
    msr  cpsr, #(CPSR_SVC|CPSR_INTLOCK) 
	ldr  r0, =_kernel_istkpt
    ldr  sp, [r0]

	/*
	 * IRQ[hֈڍs, IRQ/FIQ֎~
	 */
	msr   CPSR_c,#(CPSR_IRQ|CPSR_INTLOCK)
	ldr   r0, =__irq_stack__
	mov   sp,r0
	bic   sp,sp,#7    /* X^bN|C^8oCgEɃAC */
	
	/*
	 * VXe[hֈڍs, IRQ/FIQ֎~
	 */
	msr   CPSR_c,#(CPSR_SYS|CPSR_INTLOCK)
	ldr   r3, =__system_stack__
	mov   sp, r3
	bic   sp,sp,#7    /* X^bN|C^8oCgEɃAC */

	/*
	 * t[|C^̏
	 */
    mov  fp, #0        /* ARM[hpt[|C^(r11) */         
    mov  r7, #0        /* Thumb[hpt[|C^    */


    /*
     *  software_init_hook ďoi0 łȂꍇj
     *
     *  \tgEFAiɃCujɈˑĕKvȏ
     *  ꍇ́Csoftware_init_hook Ƃ֐pӂ
     *  悢D
     */
    ldr   r0, =software_init_hook
    cmp   r0, #0x00
    movne lr, pc
    movne pc, r0

	
	/*
	 * J[lN
	 */
	b sta_ker

	/*
	 * Little helper funcs
	 */
mem_copy_func:
	cmp   r0,r2
	bxeq  lr
	
	mov   r3,r0
	orr   r3,r3,r1
	orr   r3,r3,r2
	ands  r3,r3,#15
	beq     mcf_16_aligned
	
mcf_loop:
	cmp   r0,r1
	ldrlo r3,[r2],#4 
	strlo r3,[r0],#4 
	blo   mcf_loop
	bx    lr

mcf_16_aligned:
	cmp   r0,r1
	ldmloia r0!,{r3-r6}
	stmloia r2!,{r3-r6}
	blo   mcf_16_aligned
	bx    lr
	

mem_init_func:
	orr   r3,r0,r1
	ands  r3,r2,#15
	beq   mif_16_aligned
mif_loop:
	cmp   r0,r1
	strlo r2,[r0],#4 
	blo   mif_loop
	bx    lr

mif_16_aligned:
	mov   r3,r2
	mov   r4,r2
	mov   r5,r2
mif_16_loop:
	cmp   r0,r1
	stmloia r0!,{r2-r5}
	blo   mif_16_loop
	bx    lr
