/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006-2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_support.S 746 2008-02-23 04:46:56Z ertl-ishikawa $
 */

/*
 *  åװ¸⥸塼 ֥AT91SAM7Sѡ
 */

#define  TOPPERS_MACRO_ONLY
#define UINT_C(val)		(val)		/* uint_tޥ */
#define ULONG_C(val)	(val)		/* ulong_tޥ */
#include "kernel_impl.h"

/*
 *  ٥Υåȥƥ¸ν
 *
 *  ȥåץ⥸塼ǡ˸ƤӽФ롥          
 */
        .text
        .align 2
        .global hardware_init_hook
hardware_init_hook:
	/*
     * MC_FMR:
	 *   Set up flash memory accessing and memory for 48 MHz FMCN = 50)
	 *   2 wait states (FWS = 1)
	 *   No special flags
	 */
	ldr r0,=0xFFFFFF60
	ldr r1,=((72 << 16) | (1 << 8))
	str r1,[r0]

	/*
	 *    Disable watchdog
	 *    Set MDT_MR disable bit. 
	 *    Note: probably want to set this differently at some stage...
	 */
	ldr r0,=0xFFFFFD44
	ldr r1,=0x00008000
	str r1,[r0]

	/*
	 *    Set up PLL & clock source
	 *    The main crystal is 18.432 MHz
	 *    We want as close as we can get to 48MHz
	 *    We use the PLL to generate 18432000 / 14 * 73 = 96109714
	 *    We then divide this by 2
	 *
	 *  Start main osc
	 */
	ldr r0,=0xFFFFFC20  /* PMC_MOR */
	ldr r1,=0x00000601
	str r1,[r0]

	ldr r0,=0xFFFFFC68  /* PMC_SR */
wait_MOSCS:
	ldr r1,[r0]
	ands r1,r1,#1
	beq wait_MOSCS

	/*
	 * set up PLL
	 */
	ldr r0,=0xFFFFFC2C  /* PMC_PLLR */
	ldr r1,=0x00481C0E
	str r1,[r0]

	ldr r0,=0xFFFFFC68  /* PMC_SR */
wait_pll_lock:
	ldr r1,[r0]
	ands r1,r1,#4
	beq wait_pll_lock

	ldr r0,=0xFFFFFC68  /* PMC_SR */
wait_MCLK_Ready0:
	ldr r1,[r0]
	ands r1,r1,#8
	beq  wait_MCLK_Ready0

	/*
	 * Set up master clock to use clock div 2
	 */
	ldr r0,=0xFFFFFC30 /* PMC_MCKR */
	ldr r1,=0x4
	str r1,[r0]

	ldr r0,=0xFFFFFC68  /* PMC_SR */
wait_MCLK_Ready1:
	ldr r1,[r0]
	ands r1,r1,#8
	beq  wait_MCLK_Ready1

	/*
	 * Set up master clock to use PLL clock div 2
	 */
	ldr r0,=0xFFFFFC30 /* PMC_MCKR */
	ldr r1,=0x7
	str r1,[r0]

	ldr r0,=0xFFFFFC68  /* PMC_SR */
wait_MCLK_Ready2:
	ldr r1,[r0]
	ands r1,r1,#8
	beq  wait_MCLK_Ready2
	
init_done:
	mov     pc, lr


        .text
        .align 2
        .global software_init_hook
software_init_hook:
        mov     pc, lr

        .text
        .align 2
        .global software_term_hook
software_term_hook:
        mov     pc, lr


/*
 * ߥϥɥ
 *
 * IRQ 㳰٥ƤӽФ
 */
    .text
    .align 2
    .global irq_handler
irq_handler:
    /* 
     * IRQ⡼ɤǼ¹Ԥ
     */
	/* ȯlrIRQ⡼ɤΥåѤ */
	sub   lr,lr,#4
	stmfd sp!,{lr}

	/* ȯspsrIRQ⡼ɤΥåѤ */
	mrs   lr,spsr
	stmfd sp!,{lr}

	/* װֹIRQ⡼ɤΥåѤ */
    ldr   lr, =TADR_AIC_BASE       
    ldr   lr, [lr, #TOFF_AIC_IVR]
	stmfd sp!, {lr}

	/* Ϥưʤ <--- protect mode */
/*  ldr   lr, =TADR_AIC_BASE
 *	add   lr, lr, #TOFF_AIC_IVR
 *	str   lr,[lr]
 */
	/**********************************************/

	/* 
     *  Υ⡼(ѡХ⡼)
     *  ܹԤƥȤ¸
     */
    msr   cpsr, #(CPSR_SVC|CPSR_IRQ_BIT)
	stmfd sp!, {r0-r3,ip,lr,pc} /* pcϥߡ */

    /*
     * װֹspsrϤ뤿IRQ⡼ɤ
     */
    msr   cpsr, #(CPSR_IRQ|CPSR_IRQ_BIT)
	ldmfd sp!, {r3} /* װֹ */
	ldmfd sp!, {r1} /* spsr */
	ldmfd sp!, {r0} /*  */

    /*
     *  ߥϥɥ¹ԻΥ⡼ɡʥѡХ⡼ɡˤ
	 *  Ϥspsr򥹡ѡХ⡼ѤΥåѤ
     */
	msr   cpsr, #(CPSR_SVC|CPSR_IRQ_BIT)
	str   r0, [sp,#0x18] /*  */
	stmfd sp!,{r1}       /* spsr */
	mov   lr, sp         /* λΥåΤ */

    /*
     *  ¿ųߤȽ
     */
    ldr   r2, =excpt_nest_count /* 㳰ߥͥȲ */
    ldr   r1, [r2]
    add   r0, r1, #1            /* 㳰ߥͥȲ򹹿 */
    str   r0, [r2]
    cmp   r1, #0    
    bne   irq_handler_1

    /* 
     * ܤ㳰ʳߡˤʤ饹åѹ
     */
    ldr   r0, =_kernel_istkpt
    ldr   sp, [r0]

irq_handler_1:
    stmfd sp!, {lr}     /* ѤΥåݥ󥿤¸ */

    /*
     *  װγͥ٤(ǥ)ͥ٥ޥ򥻥å
     *  롥ޤκݡϥɥ¹(ǥ)ͥ٥ޥ
     *  ¸롥
     */
    ldr   r0, =inh_ipm_tbl      /* ͥ٤ */
    ldr   r1, [r0, r3, lsl #2]  /* r1<-ͥ   */
    ldr   r0, =ipm              /* ȯγͥ٥ޥ򥹥å¸ */
    ldr   r2, [r0]              
    stmfd sp!,{r2}
    str   r1, [r0]              /* (ǥ)ͥ٥ޥ򥻥å */

    /*
     * ϡɥ(IRC)ϳߤդ塤ߤ˱ͥ٥ޥ
     * 򥻥åȤ롥Τ᥽եȥŪˤä˽ϹԤɬפϤʤ
     * եȥŪ(ǥ)ͥ٥ޥ夲ݤˤϡ
     * ͥ٥ޥ˱Ƴ׵ػߥե饰ˤߤػߤ롥
     */
    /*
     *  ߥϥɥεưϤ
     */
    ldr   r0, =inh_tbl         /* ߥϥɥơ֥ɤ߽Ф  */
    ldr   r0, [r0, r3, lsl #2] /* r0<-ߥϥɥ            */    
	
    stmfd sp!,{r3}             /* inhno ¸  */

    /* 
     * ߵ 
     */         
    msr   cpsr, #(CPSR_SVC)
	
#ifdef LOG_INH_ENTER
    stmfd sp!,{r0}
    mov   r0, r3         /* inhno ѥ᡼    */
    bl    log_inh_enter  /* log_inh_enterƤӽФ */
    ldmfd sp!,{r0}
#endif /* LOG_INH_ENTER */

    /* 
     * ߥϥɥθƤӽФ
     */
    mov   lr, pc
    bx r0

    ldmfd sp!,{r0}       /* inhno   */    
#ifdef LOG_INH_LEAVE
    bl    log_inh_leave  /* log_inh_leaveƤӽФ */
#endif /* LOG_INH_LEAVE */

    /*
     * ͥγߤػߤ
     */
    msr   cpsr, #(CPSR_SVC|CPSR_IRQ_BIT)
	
    /*
     * ߥꥢ
     */
    ldr   r3, =TADR_AIC_BASE
    mov   r0, #0
    str   r0, [r3, #TOFF_AIC_EOICR]
    
    b     target_ret_int


/*
 * åȰ¸㳰
 */
    .text
    .global target_exc_handler
target_exc_handler:    
    /*
     *  㳰¹ԤΥ⡼ɡʥѡХ⡼ɡˤ
     *  ߥå֡CPUå֤CPU㳰ȯ
     *  ֤Ѿ롥
     */
    msr   cpsr, #(CPSR_SVC|CPSR_FIQ_BIT|CPSR_IRQ_BIT) 
    str   r0, [sp, #0x18] /* Ϥ򥹥å */
    stmfd sp!, {r1}       /* spsr򥹥å¸ */    
    mov   lr, sp          /* λΥåΤ */

    ldr   r0, =ipm        /* ȯγͥ٥ޥ򥹥å¸ */
    ldr   r1, [r0]              
    stmfd sp!, {r1}

    /* 
     * ƥȽΤᡤexcpt_nest_count 򥹥å¸
     * å¸ߤexcpt_nest_count-1ȼǤ뤬
     * åѤǤǥХåԤ䤹Τǡå
     * ¸롥
     */
    ldr   r0, =excpt_nest_count
    ldr   r1, [r0]
    stmfd sp!, {r1}

    mov   r3,  sp         /* 㳰ե졼Ϥ¸ */

    /*
     *  ¿ųߤȽ
     */
    ldr   r0, =excpt_nest_count
    ldr   r1, [r0]
    add   r1, r1, #1
    str   r1, [r0]
    cmp   r1, #1
    bne   target_exc_handler_1    

    /* 
     * ܤμ¹Ԥʤ饹åѹ
     */
    ldr  r0, =_kernel_istkpt
    ldr  sp, [r0]

target_exc_handler_1:    
    stmfd sp!, {lr}     /* ѤΥåݥ󥿤¸ */

    /* 
     * ȯγͥ٥ޥ򥹥å¸ 
     * ߥϥɥȽи롼ͭ뤿¸
     */
    ldr   r0, =ipm       
    ldr   r1, [r0]              
    stmfd sp!, {r1}

    /*
     *  CPU㳰ϥɥεưϤ
     */
    ldr   r0, =exch_tbl        /* ߥϥɥơ֥ɤ߽Ф */
    ldr   r1, [r0, r2, lsl #2] /* r1<-㳰ϥɥ                 */

    stmfd sp!,{r2}      /* excno ¸ */
    /* 
     * ߵ 
     * CPUå֡ߥå֤ϷѾ
     */         
    ldr   r0, [lr]
    and   r0, r0, #(CPSR_IRQ_BIT|CPSR_FIQ_BIT)
    orr   r0, r0, #(CPSR_SVC)
    msr   cpsr, r0

#ifdef LOG_EXC_ENTER
    stmfd sp!,{r1,r3}
    mov   r0, r2         /* excno ѥ᡼    */
    bl    log_exc_enter  /* log_exc_enterƤӽФ */
    ldmfd sp!,{r1,r3}
#endif /* LOG_EXC_ENTER */

    /* 
     * CPU㳰ϥɥθƤӽФ
     *
     * 㳰ե졼ƬȤϤ
     */        
    mov   r0, r3
    mov   lr, pc
    mov   pc, r1

    ldmfd sp!,{r0}       /* excno   */    
#ifdef LOG_EXC_LEAVE
    bl    log_exc_leave  /* log_exc_leaveƤӽФ */
#endif /* LOG_EXC_LEAVE */

/*
 * åȰ¸㳰ߤνи
 *
 */

    .global target_ret_exc
target_ret_exc:
    /*
     * ͥγߤػߤ
     */
    msr   cpsr, #(CPSR_SVC|CPSR_IRQ_BIT)

    .global target_ret_int
target_ret_int:        
    /*
     * ͥ٥ޥ򸵤᤹
     */
    ldmfd sp!, {r1}             /* γͥ٥ޥ */
    ldr   r0, =ipm              /* ͥ٥ޥ     */
    str   r1, [r0]
    rsb   r1, r1, #0            /* ǥåȤ뤿ȿž   */              
    ldr   r0, =ipm_mask_tbl     /* (ǥ)γͥ٤Τ¸뤿 */
    ldr   r2, [r0, r1, lsl #2]  /* ׵ػߥե饰 */    
    ldr   r0, =idf              /* Ƴߤγ׵ػߥե饰ξ֤ */
    ldr   r1, [r0]
    /*
     * Ƴߤγ׵ػߥե饰ξ֤(ǥ)γͥ٤Τ¸
     * γ׵ػߥե饰ξ֤ORȤꡤ뤳Ȥˤꡤ
     * IRCγߵĥ쥸ؤͤꤹ롥
     */
    ldr   r0, =TADR_AIC_BASE    /* äߤγ׵ޥ */
    mvn   lr, #0                
    str   lr, [r0, #TOFF_AIC_IDCR]                                
    orr   r1, r1, r2            /* ޥꤵƤʤߤε */
    mvn   r1, r1                /* ͤ */    
    str   r1, [r0, #TOFF_AIC_IECR]

    /*
     * åݥ󥿤
     */
    ldmfd sp!, {r2}             /* Υåݥ󥿤 */
    mov   sp, r2
    
    /*
     * νARM¸Ǽ¹
     */            
    b     ret_int


/*
 * ꥻåȽ
 */
	.global target_stop
target_stop:
	msr cpsr, #(CPSR_IRQ_BIT | CPSR_FIQ_BIT | CPSR_SVC) /* ߶ػ & ѡХ⡼ */

	/*
	 * PITν
	 */
	ldr r0, =TADR_PIT_BASE
	mov r1, #0
	str r1, [r0, #TOFF_PIT_MR]

	/* ꥻå */
	b start


